#pragma once

#include <csrmath.h>
#include <csrmath_vector.h>

namespace csrmath {

class MinimizableFunction {
public:
	virtual double operator() (const VectorD& args) = 0;
};

struct Minimizer_Ctx;
class Minimizer {
	Minimizer_Ctx *ctx;
	size_t arg_count;
	MinimizableFunction *func;

public:
	Minimizer(size_t nargs);
	~Minimizer();

	bool setFunction(MinimizableFunction* func);
	bool setArgument(size_t n, double min, double max, double start);
	VectorD minimize();
};

};
