#pragma once

namespace csrmath {

inline intx_t GCD(intx_t num1, intx_t num2) {
	if( num1 == num2 )
		return num1;
	if( num1 < num2 )
		return GCD(num2,num1);
	intx_t r1, r2 = num1, r3 = num2;
	do {
		r1 = r2;
		r2 = r3;
		r3 = r1 % r2;
	} while( r3 != 0 );
	return r2;
}

inline size_t factorial(size_t n) {
	size_t k = 1;
	for( size_t i=1; i<=n; i++ )
		k *= i;
	return k;
}

inline double factorial_d(size_t n) {
	double k = 1.0;
	for( size_t i=0; i<=n; i++ )
		k *= i;
	return k;
}

inline int64_t binomial(int64_t p, int64_t q) {
	if( q<0 || q>p )
		return 0;
	return factorial(p) / factorial(q) / factorial(p-q);
}

inline double binomial_d(int64_t p, int64_t q) {
	if( q<0 || q>p )
		return 0;
	return factorial_d(p) / factorial_d(q) / factorial_d(p-q);
}

};